Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14398)
@@ -8,5 +8,5 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public class ExecExpandExpression : Expression
+    public class ExecExpandExpression : StatefullExpression
     {
         private const string prefix = "( ";
@@ -15,11 +15,14 @@
 
         public readonly Expression[] Expressions;
+        public readonly bool IsEmpty;
+
         private List<Expression> treeIndex;
 
         public static readonly Expression Empty = new ExecExpandExpression(new Expression[0]);
 
-        public ExecExpandExpression(Expression[] expressions) : base()
-        {
-            this.Expressions = expressions;
+        public ExecExpandExpression(Expression[] expressions)
+        {
+            Expressions = expressions;
+            IsEmpty = expressions.Length == 0;
         }
 
@@ -27,11 +30,13 @@
         public ExecExpandExpression(ExecExpandExpression original, Cloner cloner) : base(original, cloner)
         {
-            this.Expressions = new Expression[original.Expressions.Length];
-            Array.Copy(original.Expressions, this.Expressions, original.Expressions.Length);
+            Expressions = new Expression[original.Expressions.Length];
+            Array.Copy(original.Expressions, Expressions, original.Expressions.Length);
 
             if (original.treeIndex != null)
             {
-                this.treeIndex = original.treeIndex.Select(e => cloner.Clone(e)).ToList();
-            }
+                treeIndex = original.treeIndex.Select(e => cloner.Clone(e)).ToList();
+            }
+
+            IsEmpty = original.IsEmpty;
         }
 
@@ -54,40 +59,32 @@
         }
 
-        private string GetStringRepresentation()
-        {
-            if (this.StringRepresentation == null)
-            {
-                var sb = new StringBuilder();
-
-                sb.Append(prefix);
-
-                for (var i = this.Expressions.Length - 1; i >= 0; i--)
+        protected override string InitStringRepresentation()
+        {
+            var sb = new StringBuilder();
+
+            sb.Append(prefix);
+
+            for (var i = Expressions.Length - 1; i >= 0; i--)
+            {
+                sb.Append(Expressions[i].ToString() + delimiter);
+            }
+
+            sb.Append(postfix);
+
+            return sb.ToString();
+        }
+
+        protected override int InitId()
+        {
+            unchecked
+            {
+                var hash = 19;
+                foreach (var e in Expressions)
                 {
-                    sb.Append(this.Expressions[i].ToString() + delimiter);
+                    hash *= 31 + e.GetHashCode();
                 }
 
-                sb.Append(postfix);
-
-                this.StringRepresentation = sb.ToString();
-            }
-
-            return this.StringRepresentation;
-        }
-
-        private int GetId()
-        {
-            if (this.Id == default(int))
-            {
-                unchecked
-                {
-                    this.Id = 19;
-                    foreach (var e in Expressions)
-                    {
-                        this.Id *= 31 + e.GetHashCode();
-                    }
-                }
-            }
-
-            return this.Id;
+                return hash;
+            }
         }
 
@@ -97,4 +94,9 @@
         }
 
+        public override int GetHashCode()
+        {
+            return base.GetHashCode();
+        }
+
         public override bool Equals(object obj)
         {
@@ -111,20 +113,10 @@
             var other = obj as ExecExpandExpression;
 
-            return this.Expressions.SequenceEqual(other.Expressions);
-        }
-
-        public override int GetHashCode()
-        {
-            return this.GetId();
-        }
-
-        public override string ToString()
-        {
-            return this.GetStringRepresentation();
-        }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            interpreter.ExecStack.Push(this.Expressions);
+            return Expressions.SequenceEqual(other.Expressions);
+        }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            interpreter.ExecStack.Push(Expressions);
         }
 
@@ -137,7 +129,7 @@
             get
             {
-                this.BuildIndexIfNecessary();
-
-                return this.treeIndex.Count;
+                BuildIndexIfNecessary();
+
+                return treeIndex.Count;
             }
         }
@@ -150,30 +142,30 @@
         public Expression GetFromTree(int index)
         {
-            this.BuildIndexIfNecessary();
-
-            return this.treeIndex[index];
+            BuildIndexIfNecessary();
+
+            return treeIndex[index];
         }
 
         private void BuildIndexIfNecessary()
         {
-            if (this.treeIndex != null)
-                return;
-
-            this.treeIndex = new List<Expression>(this.Expressions.Length) { this };
-
-            for (var i = this.Expressions.Length - 1; i >= 0; i--)
-            {
-                var subExpression = this.Expressions[i];
+            if (treeIndex != null)
+                return;
+
+            treeIndex = new List<Expression>(Expressions.Length) { this };
+
+            for (var i = Expressions.Length - 1; i >= 0; i--)
+            {
+                var subExpression = Expressions[i];
 
                 if (subExpression.GetType() == typeof(ExecExpandExpression))
                 {
-                    var list = subExpression as ExecExpandExpression;
-
-                    list.BuildIndexIfNecessary();
-                    this.treeIndex.AddRange(list.treeIndex);
+                    var expand = subExpression as ExecExpandExpression;
+
+                    expand.BuildIndexIfNecessary();
+                    treeIndex.AddRange(expand.treeIndex);
                 }
                 else
                 {
-                    this.treeIndex.Add(subExpression);
+                    treeIndex.Add(subExpression);
                 }
 
@@ -188,7 +180,7 @@
     /// the BOOLEAN stack.
     /// </summary>
-    public class ExecIfExpression : Expression
-    {
-        public ExecIfExpression() : base("EXEC.IF") { }
+    public class ExecIfExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "EXEC.IF"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -212,9 +204,7 @@
     /// "( EXEC.Y <TopItem> )".
     /// </summary>
-    public class ExecYExpression : Expression
-    {
-        public ExecYExpression() : base("EXEC.Y")
-        {
-        }
+    public class ExecYExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "EXEC.Y"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -237,7 +227,7 @@
     /// The Push implementation of the "K combinator". Removes the second item on the EXEC stack.
     /// </summary>
-    public class ExecKExpression : Expression
-    {
-        public ExecKExpression() : base("EXEC.K") { }
+    public class ExecKExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "EXEC.K"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -256,7 +246,7 @@
     /// another instance of C, followed by another instance of A.
     /// </summary>
-    public class ExecSExpression : Expression
-    {
-        public ExecSExpression() : base("EXEC.S") { }
+    public class ExecSExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "EXEC.S"; }
 
         public override void Eval(IInterpreter interpreter)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14398)
@@ -6,45 +6,64 @@
     public abstract class Expression : DeepCloneable
     {
-        public Expression() { }
+        private string stringRepresentation;
+        private int id;
 
-        public Expression(string stringRepresenation) : this(stringRepresenation, stringRepresenation.GetHashCode())
+        public Expression()
         { }
 
-        public Expression(string stringRepresenation, int id)
+        /// <summary>
+        /// Clone Constructor
+        /// </summary>
+        protected Expression(Expression origin, Cloner cloner)
         {
-            this.StringRepresentation = stringRepresenation;
-            this.Id = id;
+            stringRepresentation = origin.stringRepresentation;
+            id = origin.id;
         }
-
-        // copy constructor
-        public Expression(Expression original, Cloner cloner) : base(original, cloner)
-        {
-            this.StringRepresentation = original.StringRepresentation;
-            this.Id = original.Id;
-        }
-
-        protected int Id { get; set; }
-        protected string StringRepresentation { get; set; }
 
         public abstract void Eval(IInterpreter interpreter);
 
-        public override string ToString()
+        protected abstract int InitId();
+
+        protected abstract string InitStringRepresentation();
+
+        public string StringRepresentation
         {
-            return this.StringRepresentation;
+            get
+            {
+                if (stringRepresentation == null)
+                {
+                    stringRepresentation = InitStringRepresentation();
+                }
+
+                return stringRepresentation;
+            }
+        }
+
+        public int Id
+        {
+            get
+            {
+                if (id == default(int))
+                {
+                    id = InitId();
+                }
+
+                return id;
+            }
         }
 
         public override bool Equals(object obj)
         {
-            return obj != null && this.GetType() == obj.GetType();
+            return obj != null && (GetHashCode() == obj.GetHashCode() || GetType() == obj.GetType());
+        }
+
+        public override string ToString()
+        {
+            return StringRepresentation;
         }
 
         public override int GetHashCode()
         {
-            return this.Id;
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return this;
+            return Id;
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FloatExpressions.cs	(revision 14398)
@@ -9,10 +9,9 @@
     public class FloatAddExpression : PushResultExpression<double>
     {
-        public FloatAddExpression() : base("FLOAT.+")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
+        protected override string InitStringRepresentation() { return "FLOAT.+"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
         }
     }
@@ -23,10 +22,9 @@
     public class FloatSubtractExpression : PushResultExpression<double>
     {
-        public FloatSubtractExpression() : base("FLOAT.-")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
+        protected override string InitStringRepresentation() { return "FLOAT.-"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
         }
     }
@@ -37,10 +35,9 @@
     public class FloatMultiplyExpression : PushResultExpression<double>
     {
-        public FloatMultiplyExpression() : base("FLOAT.*")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
+        protected override string InitStringRepresentation() { return "FLOAT.*"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
         }
     }
@@ -52,10 +49,9 @@
     public class FloatDivideExpression : PushResultExpression<double>
     {
-        public FloatDivideExpression() : base("FLOAT./")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
+        protected override string InitStringRepresentation() { return "FLOAT./"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
         }
     }
@@ -69,10 +65,9 @@
     public class FloatModuloExpression : PushResultExpression<double>
     {
-        public FloatModuloExpression() : base("FLOAT.%")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
+        protected override string InitStringRepresentation() { return "FLOAT.%"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
         }
     }
@@ -83,10 +78,9 @@
     public class FloatMinExpression : PushResultExpression<double>
     {
-        public FloatMinExpression() : base("FLOAT.MIN")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
+        protected override string InitStringRepresentation() { return "FLOAT.MIN"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
         }
     }
@@ -97,10 +91,9 @@
     public class FloatMaxExpression : PushResultExpression<double>
     {
-        public FloatMaxExpression() : base("FLOAT.MAX")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
+        protected override string InitStringRepresentation() { return "FLOAT.MAX"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
         }
     }
@@ -111,10 +104,9 @@
     public class FloatSmallerThanExpression : PushResultExpression<double>
     {
-        public FloatSmallerThanExpression() : base("FLOAT.<")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(
+        protected override string InitStringRepresentation() { return "FLOAT.<"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(
                 interpreter.FloatStack,
                 interpreter.BooleanStack,
@@ -129,10 +121,9 @@
     public class FloatGreaterThanExpression : PushResultExpression<double>
     {
-        public FloatGreaterThanExpression() : base("FLOAT.>")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(
+        protected override string InitStringRepresentation() { return "FLOAT.>"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(
                 interpreter.FloatStack,
                 interpreter.BooleanStack,
@@ -147,10 +138,9 @@
     public class FloatSineExpression : PushResultExpression<double>
     {
-        public FloatSineExpression() : base("FLOAT.SIN")
-        { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(
+        protected override string InitStringRepresentation() { return "FLOAT.SIN"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(
                 interpreter.FloatStack,
                 1,
@@ -164,9 +154,9 @@
     public class FloatCosineExpression : PushResultExpression<double>
     {
-        public FloatCosineExpression() : base("FLOAT.COS") { }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            this.Eval(
+        protected override string InitStringRepresentation() { return "FLOAT.COS"; }
+
+        public override void Eval(IInterpreter interpreter)
+        {
+            Eval(
                 interpreter.FloatStack,
                 1,
@@ -178,7 +168,7 @@
     /// Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
     /// </summary>
-    public class FloatFromBooleanExpression : Expression
-    {
-        public FloatFromBooleanExpression() : base("FLOAT.FROMBOOLEAN") { }
+    public class FloatFromBooleanExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "FLOAT.FROMBOOLEAN"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -197,9 +187,7 @@
     /// Pushes a floating point version of the top INTEGER.
     /// </summary>
-    public class FloatFromIntegerExpression : Expression
-    {
-        public FloatFromIntegerExpression() : base("FLOAT.FROMINTEGER")
-        {
-        }
+    public class FloatFromIntegerExpression : StatelessExpression
+    {
+        protected override string InitStringRepresentation() { return "FLOAT.FROMINTEGER"; }
 
         public override void Eval(IInterpreter interpreter)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs	(revision 14398)
@@ -8,9 +8,6 @@
     /// </summary>
     /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class FlushExpression<T> : Expression
+    public abstract class FlushExpression<T> : StatelessExpression
     {
-        public FlushExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack)
         {
@@ -21,10 +18,9 @@
     public class IntegerFlushExpression : FlushExpression<long>
     {
-        public IntegerFlushExpression() : base("INTEGER.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
     }
@@ -32,10 +28,9 @@
     public class FloatFlushExpression : FlushExpression<double>
     {
-        public FloatFlushExpression() : base("FLOAT.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
     }
@@ -43,10 +38,9 @@
     public class BooleanFlushExpression : FlushExpression<bool>
     {
-        public BooleanFlushExpression() : base("BOOLEAN.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
     }
@@ -54,10 +48,9 @@
     public class NameFlushExpression : FlushExpression<string>
     {
-        public NameFlushExpression() : base("NAME.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
     }
@@ -65,10 +58,9 @@
     public class ExecFlushExpression : FlushExpression<Expression>
     {
-        public ExecFlushExpression() : base("EXEC.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack);
+            Eval(interpreter.ExecStack);
         }
     }
@@ -76,10 +68,9 @@
     public class CodeFlushExpression : FlushExpression<Expression>
     {
-        public CodeFlushExpression() : base("CODE.FLUSH")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.FLUSH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack);
+            Eval(interpreter.CodeStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs	(revision 14398)
@@ -9,9 +9,9 @@
     public class IntegerAddExpression : PushResultExpression<long>
     {
-        public IntegerAddExpression() : base("INTEGER.+") { }
+        protected override string InitStringRepresentation() { return "INTEGER.+"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
+            Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
         }
     }
@@ -22,9 +22,9 @@
     public class IntegerSubtractExpression : PushResultExpression<long>
     {
-        public IntegerSubtractExpression() : base("INTEGER.-") { }
+        protected override string InitStringRepresentation() { return "INTEGER.-"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
+            Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
         }
     }
@@ -35,9 +35,9 @@
     public class IntegerMultiplyExpression : PushResultExpression<long>
     {
-        public IntegerMultiplyExpression() : base("INTEGER.*") { }
+        protected override string InitStringRepresentation() { return "INTEGER.*"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
+            Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
         }
     }
@@ -49,9 +49,9 @@
     public class IntegerDivideExpression : PushResultExpression<long>
     {
-        public IntegerDivideExpression() : base("INTEGER./") { }
+        protected override string InitStringRepresentation() { return "INTEGER./"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
+            Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
         }
     }
@@ -65,9 +65,9 @@
     public class IntegerModuloExpression : PushResultExpression<long>
     {
-        public IntegerModuloExpression() : base("INTEGER.%") { }
+        protected override string InitStringRepresentation() { return "INTEGER.%"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
+            Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
         }
     }
@@ -78,9 +78,9 @@
     public class IntegerMinExpression : PushResultExpression<long>
     {
-        public IntegerMinExpression() : base("INTEGER.MIN") { }
+        protected override string InitStringRepresentation() { return "INTEGER.MIN"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
+            Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
         }
     }
@@ -91,9 +91,9 @@
     public class IntegerMaxExpression : PushResultExpression<long>
     {
-        public IntegerMaxExpression() : base("INTEGER.MAX") { }
+        protected override string InitStringRepresentation() { return "INTEGER.MAX"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
+            Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
         }
     }
@@ -104,9 +104,9 @@
     public class IntegerSmallerThanExpression : PushResultExpression<long>
     {
-        public IntegerSmallerThanExpression() : base("INTEGER.<") { }
+        protected override string InitStringRepresentation() { return "INTEGER.<"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(
+            Eval(
                 interpreter.IntegerStack,
                 interpreter.BooleanStack,
@@ -121,9 +121,9 @@
     public class IntegerGreaterThanExpression : PushResultExpression<long>
     {
-        public IntegerGreaterThanExpression() : base("INTEGER.>") { }
+        protected override string InitStringRepresentation() { return "INTEGER.>"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(
+            Eval(
                 interpreter.IntegerStack,
                 interpreter.BooleanStack,
@@ -136,7 +136,7 @@
     /// Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
     /// </summary>
-    public class IntegerFromBooleanExpression : Expression
+    public class IntegerFromBooleanExpression : StatelessExpression
     {
-        public IntegerFromBooleanExpression() : base("INTEGER.FROMBOOLEAN") { }
+        protected override string InitStringRepresentation() { return "INTEGER.FROMBOOLEAN"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -155,7 +155,7 @@
     /// Pushes the result of truncating the top FLOAT.
     /// </summary>
-    public class IntegerFromFloatExpression : Expression
+    public class IntegerFromFloatExpression : StatelessExpression
     {
-        public IntegerFromFloatExpression() : base("INTEGER.FROMFLOAT") { }
+        protected override string InitStringRepresentation() { return "INTEGER.FROMFLOAT"; }
 
         public override void Eval(IInterpreter interpreter)
